> ## Documentation Index
> Fetch the complete documentation index at: https://docs.siftstack.com/llms.txt
> Use this file to discover all available pages before exploring further.

# CreatePanelConfiguration

> Creates a panel configuration.



## OpenAPI

````yaml /openapi.json post /api/v1/panel-configurations
openapi: 3.0.0
info:
  title: Sift API
  version: '1.0'
servers:
  - url: https://api.siftstack.com
    description: Production
  - url: https://gov.api.siftstack.com
    description: Gov
security:
  - BearerAuth: []
tags:
  - name: TagService
    description: Service to programmatically interact with [tags](/glossary#tag).
  - name: CampaignService
  - name: ProtobufDescriptorService
    description: >-
      Service to programmatically interact with protobuf descriptors used for
      protobuf ingestion.
    externalDocs:
      description: Read more about what protobuf ingestion.
      url: /ingestion/protobuf_ingestion
  - name: AnnotationLogService
    description: >-
      Service to programmatically interact with [annotation
      logs](/glossary#annotation).
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: MetadataService
  - name: DlqErrorsService
  - name: RuleService
    description: Service to programmatically interact with rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: WebhookService
  - name: UserDefinedFunctionService
  - name: ReportTemplateService
  - name: RemoteFileService
  - name: PingService
  - name: FamilyService
    description: Service to programmatically interact with family configurations.
  - name: ExternalSyncService
  - name: ReportService
  - name: NotificationService
    description: Service to programmatically interact with in-app notifications.
  - name: ChannelSchemaService
    description: Service to programmatically interact with channel schemas
  - name: IngestService
  - name: UserService
    description: Service to programmatically interact with user objects.
  - name: TestReportService
    description: Service to manage test reports
  - name: PrincipalAttributeService
    description: Service to manage ABAC principal attributes.
  - name: ChannelService
    description: Service to programmatically interact with [channels](/glossary#channel).
    externalDocs:
      description: Read more about what channels are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265453943
  - name: DataImportService
  - name: ExportService
  - name: PolicyService
    description: Service to manage ABAC policies.
  - name: ApiKeyService
  - name: CommentService
    description: >-
      Service to programmatically interact with comments attached to resources
      in the platform.
  - name: JobService
  - name: UserGroupService
  - name: ResourceAttributeService
    description: Service to manage ABAC resource attributes (entity attributes).
  - name: AutomationService
  - name: ViewService
    description: Service to programmatically interact with views.
    externalDocs:
      description: Read more about what views are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/298188809
  - name: UnitService
  - name: DocsService
  - name: RoleService
  - name: SavedSearchService
  - name: RuleEvaluationService
    description: Service to evaluate rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: RunService
    description: Service to programmatically interact with [runs](/glossary#run).
    externalDocs:
      description: Read more about what runs are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265454053
  - name: PanelConfigurationService
    description: Service to programmatically interact with panel configurations.
  - name: IngestionConfigService
    description: >-
      Service to programmatically interact with [ingestion
      configs](/glossary#ingestion-config).
    externalDocs:
      description: Read more about what ingestion configs are.
      url: /ingestion/creating-amend-ingestion-config
  - name: CalculatedChannelService
  - name: CalculatedChannelsService
    description: Service to programmatically interact with calculated channels.
    externalDocs:
      description: Read more about calculated channels.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421153
  - name: AnnotationService
    description: Service to programmatically interact with annotations.
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: DataService
    description: Service to query data
  - name: MeService
  - name: AssetService
    description: Service to programmatically interact with [assets](/glossary#asset).
    externalDocs:
      description: Read more about what assets are.
      url: /data-model
paths:
  /api/v1/panel-configurations:
    post:
      tags:
        - PanelConfigurationService
      summary: CreatePanelConfiguration
      description: Creates a panel configuration.
      operationId: PanelConfigurationService_CreatePanelConfiguration
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/v1CreatePanelConfigurationRequest'
        required: true
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1CreatePanelConfigurationResponse'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
components:
  schemas:
    v1CreatePanelConfigurationRequest:
      type: object
      properties:
        name:
          type: string
        channelConfigurations:
          type: array
          items:
            $ref: '#/components/schemas/v1ChannelConfigurations'
        chartSettings:
          type: object
        metadata:
          type: array
          items:
            $ref: '#/components/schemas/v1MetadataValue'
      required:
        - name
        - channelConfigurations
    v1CreatePanelConfigurationResponse:
      type: object
      properties:
        panelConfiguration:
          $ref: '#/components/schemas/v1PanelConfiguration'
    rpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
    v1ChannelConfigurations:
      type: object
      properties:
        name:
          type: string
        type:
          $ref: '#/components/schemas/v1PlottedChannelType'
        color:
          type: string
        channelSettings:
          type: object
        bitFieldIndex:
          type: integer
          format: int32
          title: bitfield
        bitFieldElement:
          $ref: '#/components/schemas/v1ChannelBitFieldElement'
        expression:
          type: string
          title: temporary calculated channel
        expressionChannelReferences:
          type: array
          items:
            $ref: '#/components/schemas/v2CalculatedChannelAbstractChannelReference'
        dataType:
          $ref: '#/components/schemas/v1ChannelDataType'
      required:
        - name
        - type
        - color
        - channelSettings
    v1MetadataValue:
      type: object
      properties:
        key:
          $ref: '#/components/schemas/v1MetadataKey'
        stringValue:
          type: string
        numberValue:
          type: number
          format: double
        booleanValue:
          type: boolean
        relationValue:
          $ref: '#/components/schemas/v1MetadataRelationValue'
        archivedDate:
          type: string
          format: date-time
        isArchived:
          type: boolean
          description: >-
            Whether the metadata value is archived. This is inferred from
            whether archived_date is set.
      required:
        - key
    v1PanelConfiguration:
      type: object
      properties:
        panelConfigurationId:
          type: string
        versionId:
          type: string
        version:
          type: integer
          format: int64
        changeMessage:
          type: string
        name:
          type: string
        channelConfigurations:
          type: array
          items:
            $ref: '#/components/schemas/v1ChannelConfigurations'
        chartSettings:
          type: object
        createdDate:
          type: string
          format: date-time
        modifiedDate:
          type: string
          format: date-time
        archivedDate:
          type: string
          format: date-time
        createdByUserId:
          type: string
        modifiedByUserId:
          type: string
        isArchived:
          type: boolean
        metadata:
          type: array
          items:
            $ref: '#/components/schemas/v1MetadataValue'
        folderIds:
          type: array
          items:
            type: string
          description: Ids of the folders this panel configuration belongs to.
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
    v1PlottedChannelType:
      type: string
      enum:
        - PLOTTED_CHANNEL_TYPE_UNSPECIFIED
        - PLOTTED_CHANNEL_TYPE_REGULAR
        - PLOTTED_CHANNEL_TYPE_CALCULATED_CHANNEL
        - PLOTTED_CHANNEL_TYPE_BIT_FIELD_ELEMENT
        - PLOTTED_CHANNEL_TYPE_ENUM
      default: PLOTTED_CHANNEL_TYPE_UNSPECIFIED
    v1ChannelBitFieldElement:
      type: object
      properties:
        name:
          type: string
        index:
          type: integer
          format: int32
          description: >-
            The index of this element's first bit in the logical bit field
            array.
        bitCount:
          type: integer
          format: int64
      required:
        - name
        - index
        - bitCount
    v2CalculatedChannelAbstractChannelReference:
      type: object
      properties:
        channelReference:
          type: string
        channelIdentifier:
          type: string
          title: >-
            must use either a channel_identifier or a
            calculated_channel_reference, not both
        calculatedChannelVersionId:
          type: string
        calculatedChannel:
          $ref: '#/components/schemas/v1ExpressionRequest'
      required:
        - channelReference
    v1ChannelDataType:
      type: string
      enum:
        - CHANNEL_DATA_TYPE_UNSPECIFIED
        - CHANNEL_DATA_TYPE_DOUBLE
        - CHANNEL_DATA_TYPE_STRING
        - CHANNEL_DATA_TYPE_ENUM
        - CHANNEL_DATA_TYPE_BIT_FIELD
        - CHANNEL_DATA_TYPE_BOOL
        - CHANNEL_DATA_TYPE_FLOAT
        - CHANNEL_DATA_TYPE_INT_32
        - CHANNEL_DATA_TYPE_UINT_32
        - CHANNEL_DATA_TYPE_INT_64
        - CHANNEL_DATA_TYPE_UINT_64
        - CHANNEL_DATA_TYPE_BYTES
      default: CHANNEL_DATA_TYPE_UNSPECIFIED
    v1MetadataKey:
      type: object
      properties:
        name:
          type: string
        type:
          $ref: '#/components/schemas/v1MetadataKeyType'
        archivedDate:
          type: string
          format: date-time
        isArchived:
          type: boolean
          description: >-
            Whether the metadata key is archived. This is inferred from whether
            archived_date is set.


            The filter field type this key maps to, so a client can build a CEL
            filter
             against it (`metadata["<name>"]`) and resolve its operators and functions
             from FilterGrammarService. Derived from `type`.
      required:
        - name
        - type
    v1MetadataRelationValue:
      type: object
      properties:
        resourceType:
          type: string
        resourceId:
          type: string
      required:
        - resourceType
        - resourceId
    v1ExpressionRequest:
      type: object
      properties:
        channelReferences:
          type: object
          additionalProperties:
            type: string
          description: >-
            A map from the channel reference in the expression string (e.g. $1)
            to the channel id (uuid).

            This is deprecated and should be passed in
            expression_channel_references instead.
        expression:
          type: string
        expressionChannelReferences:
          type: array
          items:
            $ref: '#/components/schemas/v1ExpressionChannelReference'
        functionDependencies:
          type: array
          items:
            $ref: '#/components/schemas/v1FunctionDependency'
      required:
        - expression
    v1MetadataKeyType:
      type: string
      enum:
        - METADATA_KEY_TYPE_UNSPECIFIED
        - METADATA_KEY_TYPE_STRING
        - METADATA_KEY_TYPE_NUMBER
        - METADATA_KEY_TYPE_BOOLEAN
        - METADATA_KEY_TYPE_RELATION
      default: METADATA_KEY_TYPE_UNSPECIFIED
      description: |-
        Metadata key type.

         - METADATA_KEY_TYPE_STRING: string
         - METADATA_KEY_TYPE_NUMBER: number
         - METADATA_KEY_TYPE_BOOLEAN: boolean
         - METADATA_KEY_TYPE_RELATION: relation — references another resource by UUID (e.g. folder membership)
    v1ExpressionChannelReference:
      type: object
      properties:
        channelReference:
          type: string
        channelId:
          type: string
        calculatedChannel:
          $ref: '#/components/schemas/v1ExpressionRequest'
      required:
        - channelReference
        - channelId
    v1FunctionDependency:
      type: object
      properties:
        userDefinedFunctionVersionId:
          type: string
      required:
        - userDefinedFunctionVersionId
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````